// snd.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "snd.h"

#include "MainFrm.h"
#include "sndDoc.h"
#include "sndView.h"

// added for the Sound 
#include "soundin.h"
#include "soundout.h"
#include "singenerator.h"
#include "geneparams.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSndApp

BEGIN_MESSAGE_MAP(CSndApp, CWinApp)
	//{{AFX_MSG_MAP(CSndApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(IDR_SOUND_OUT_START, OnSoundOutStart)
	ON_COMMAND(IDR_SOUND_IN_STOP, OnSoundInStop)
	ON_COMMAND(IDR_SOUND_IN_START, OnSoundInStart)
	ON_COMMAND(IDR_SOUND_OUT_STOP, OnSoundOutStop)
	ON_COMMAND(ID_GENE_PARAMS, OnGeneParams)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSndApp construction

CSndApp::CSndApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSndApp object

CSndApp theApp;
// added for the Sound 
CSoundIn SoundIn;
CSinGenerator SoundOut;
/////////////////////////////////////////////////////////////////////////////
// CSndApp initialization

BOOL CSndApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CSndDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CSndView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	// added for sound
	SoundOut.OpenOutput();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CSndApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CSndApp commands

int CSndApp::ExitInstance() 
{
    	
	SoundIn.CloseMic();
	SoundOut.CloseOutput();
	return CWinApp::ExitInstance();
}


void CSndApp::OnSoundInStart() 
{
	SoundIn.OpenMic();
}
void CSndApp::OnSoundInStop() 
{
	SoundIn.CloseMic();
}

void CSndApp::OnSoundOutStart() 
{
	SoundOut.OpenOutput();
}
void CSndApp::OnSoundOutStop() 
{
	SoundOut.CloseOutput();
}


void CSndApp::OnGeneParams() 
{
	CGeneParams GeneDlg;
	GeneDlg.m_GeneAmpl = SoundOut.Ampl;
	GeneDlg.m_GeneFreq = SoundOut.fo;

	if (GeneDlg.DoModal()!=IDCANCEL)
	{
		SoundOut.SetSinParametres(GeneDlg.m_GeneAmpl,GeneDlg.m_GeneFreq) ;
		SoundOut.Restart();
	}

}
